"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var createHTMLMarker = function createHTMLMarker(google) {
  var HTMLMarker = /*#__PURE__*/function (_google$maps$OverlayV) {
    _inherits(HTMLMarker, _google$maps$OverlayV);
    var _super = _createSuper(HTMLMarker);
    function HTMLMarker(_ref) {
      var _this;
      var position = _ref.position,
        map = _ref.map,
        className = _ref.className,
        _ref$anchor = _ref.anchor,
        anchor = _ref$anchor === void 0 ? {
          x: 0,
          y: 0
        } : _ref$anchor;
      _classCallCheck(this, HTMLMarker);
      _this = _super.call(this);
      _this.anchor = anchor;
      _this.subscriptions = [];
      _this.latLng = new google.maps.LatLng(position);
      _this.element = document.createElement('div');
      _this.element.className = className;
      _this.element.style.position = 'absolute';
      // Force the "white-space" of the element will avoid the
      // content to collapse when we move the map from center
      _this.element.style.whiteSpace = 'nowrap';
      _this.setMap(map);
      return _this;
    }
    _createClass(HTMLMarker, [{
      key: "onAdd",
      value: function onAdd() {
        if (this.getPanes()) {
          this.getPanes().overlayMouseTarget.appendChild(this.element);
        }
      }
    }, {
      key: "draw",
      value: function draw() {
        if (this.getProjection()) {
          var position = this.getProjection().fromLatLngToDivPixel(this.latLng);
          var offsetX = this.anchor.x + this.element.offsetWidth / 2;
          var offsetY = this.anchor.y + this.element.offsetHeight;
          this.element.style.left = "".concat(Math.round(position.x - offsetX), "px");
          this.element.style.top = "".concat(Math.round(position.y - offsetY), "px");

          // Markers to the south are in front of markers to the north
          // This is the default behaviour of Google Maps
          this.element.style.zIndex = parseInt(this.element.style.top, 10);
        }
      }
    }, {
      key: "onRemove",
      value: function onRemove() {
        if (this.element && this.element.parentNode) {
          this.element.parentNode.removeChild(this.element);
          this.subscriptions.forEach(function (subscription) {
            return subscription.remove();
          });
          delete this.element;
          this.subscriptions = [];
        }
      }
    }, {
      key: "addListener",
      value: function addListener(eventName, listener) {
        var _this2 = this;
        var subscription = {
          remove: function remove() {
            _this2.element.removeEventListener(eventName, listener);
            _this2.subscriptions = _this2.subscriptions.filter(function (_) {
              return _ !== subscription;
            });
          }
        };
        this.element.addEventListener(eventName, listener);
        this.subscriptions = this.subscriptions.concat(subscription);
        return subscription;
      }
    }, {
      key: "getPosition",
      value: function getPosition() {
        return this.latLng;
      }
    }]);
    return HTMLMarker;
  }(google.maps.OverlayView);
  return HTMLMarker;
};
var _default = createHTMLMarker;
exports.default = _default;