function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import PropTypes from 'prop-types';
import React from 'react';
import { createClassNames, translatable } from 'react-instantsearch-dom';
import GeoSearchContext from "./GeoSearchContext.js";
import withGoogleMaps from "./withGoogleMaps.js";
var cx = createClassNames('GeoSearch');
var RedoPropTypes = {
  googleMapsInstance: PropTypes.object.isRequired,
  translate: PropTypes.func.isRequired
};
export var Redo = function Redo(_ref) {
  var googleMapsInstance = _ref.googleMapsInstance,
    translate = _ref.translate,
    hasMapMoveSinceLastRefine = _ref.hasMapMoveSinceLastRefine,
    refineWithInstance = _ref.refineWithInstance;
  return /*#__PURE__*/React.createElement("div", {
    className: cx('control')
  }, /*#__PURE__*/React.createElement("button", {
    className: cx('redo', !hasMapMoveSinceLastRefine && 'redo--disabled'),
    disabled: !hasMapMoveSinceLastRefine,
    onClick: function onClick() {
      return refineWithInstance(googleMapsInstance);
    }
  }, translate('redo')));
};
Redo.propTypes = _objectSpread(_objectSpread({}, RedoPropTypes), {}, {
  hasMapMoveSinceLastRefine: PropTypes.bool.isRequired,
  refineWithInstance: PropTypes.func.isRequired
});
var RedoWrapper = function RedoWrapper(props) {
  return /*#__PURE__*/React.createElement(GeoSearchContext.Consumer, null, function (_ref2) {
    var hasMapMoveSinceLastRefine = _ref2.hasMapMoveSinceLastRefine,
      refineWithInstance = _ref2.refineWithInstance;
    return /*#__PURE__*/React.createElement(Redo, _extends({}, props, {
      hasMapMoveSinceLastRefine: hasMapMoveSinceLastRefine,
      refineWithInstance: refineWithInstance
    }));
  });
};
RedoWrapper.propTypes = RedoPropTypes;
export default translatable({
  redo: 'Redo search here'
})(withGoogleMaps(RedoWrapper));